VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form FMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "VB+ IProgressDialog sample"
   ClientHeight    =   2130
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5595
   Icon            =   "FMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   142
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   373
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdBrowseDest 
      Caption         =   "..."
      Height          =   285
      Left            =   5160
      TabIndex        =   7
      Top             =   1200
      Width           =   285
   End
   Begin VB.CommandButton cmdBrowseSrc 
      Caption         =   "..."
      Height          =   285
      Left            =   5160
      TabIndex        =   2
      Top             =   240
      Width           =   285
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   0
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      Filter          =   "All Files (*.*)|*.*"
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "&Close"
      Height          =   345
      Left            =   4200
      TabIndex        =   9
      Top             =   1680
      Width           =   1215
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "&Start"
      Default         =   -1  'True
      Height          =   345
      Left            =   2880
      TabIndex        =   8
      Top             =   1680
      Width           =   1215
   End
   Begin VB.OptionButton optMove 
      Caption         =   "&Move to"
      Height          =   255
      Left            =   3360
      TabIndex        =   4
      Top             =   720
      Width           =   1815
   End
   Begin VB.OptionButton optCopy 
      Caption         =   "Co&py to"
      Height          =   255
      Left            =   1560
      TabIndex        =   3
      Top             =   720
      Value           =   -1  'True
      Width           =   1455
   End
   Begin VB.TextBox txtDest 
      Height          =   285
      Left            =   1080
      TabIndex        =   6
      Top             =   1200
      Width           =   3975
   End
   Begin VB.TextBox txtSource 
      Height          =   285
      Left            =   1080
      TabIndex        =   1
      Top             =   240
      Width           =   3975
   End
   Begin VB.Label lblDest 
      Alignment       =   1  'Right Justify
      Caption         =   "&Destination"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   1260
      Width           =   855
   End
   Begin VB.Label lblSource 
      Alignment       =   1  'Right Justify
      Caption         =   "S&ource"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   300
      Width           =   855
   End
End
Attribute VB_Name = "FMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''
'' Name:         FMain
'' Filename:     FMain.bas
'' Project:      VB+ IProgressDialog sample
'' Author:       Mattias Sjgren (mattiass@hem.passagen.se)
''               http://hem.spray.se/mattias.sjogren/
''
'' Description:  IProgressDialog sample main form
''
'' Dependencies: MFileOpCallback (MFileOpCallback.bas)
''
'' History:
''
''   04/18/00 - Added workaround for PROGDLG_NOMINIMIZE bug.
''              Removed Unicode API support.
''
''
'' Copyright 2000, Mattias Sjgren
''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'''''''''''''''''''''
'''   Constants   '''
'''''''''''''''''''''

' File operation animations resource IDs in shell32.dll
Private Const RES_AVI_FILEMOVE = 160
Private Const RES_AVI_FILECOPY = 161

' CopyFileEx flags
Private Const COPY_FILE_FAIL_IF_EXISTS = &H1

' MoveFileWithProgress flags
Private Const MOVEFILE_COPY_ALLOWED = &H2

' Get/SetWindowLong flags
Private Const GWL_STYLE = (-16)

' Window styles
Private Const WS_MINIMIZEBOX = &H20000


''''''''''''''''''''
'''   Declares   '''
''''''''''''''''''''

Private Declare Function CopyFileEx Lib "kernel32" Alias "CopyFileExA" _
  (ByVal lpExistingFileName As String, _
  ByVal lpNewFileName As String, _
  ByVal lpProgressRoutine As Long, _
  lpData As Any, _
  pbCancel As Long, _
  ByVal dwCopyFlags As Long) As Long

Private Declare Function MoveFileWithProgress Lib "kernel32" Alias "MoveFileWithProgressA" _
  (ByVal lpExistingFileName As String, _
  ByVal lpNewFileName As String, _
  ByVal lpProgressRoutine As Long, _
  lpData As Any, _
  ByVal dwFlags As Long) As Long

Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" _
  (ByVal lpLibFileName As String) As Long

Private Declare Function FreeLibrary Lib "kernel32" _
  (ByVal hLibModule As Long) As Long

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" ( _
  ByVal hwnd As Long, _
  ByVal nIndex As Long) As Long

Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" ( _
  ByVal hwnd As Long, _
  ByVal nIndex As Long, _
  ByVal dwNewLong As Long) As Long


'''''''''''''''''''''
'''   Variables   '''
'''''''''''''''''''''

Private m_hLibShell32 As Long


Private Sub cmdBrowseDest_Click()

  With CommonDialog1
    .DialogTitle = "Enter a destination filename"
    .Flags = cdlOFNHideReadOnly Or cdlOFNPathMustExist Or cdlOFNOverwritePrompt
    .FileName = txtDest.Text
    .ShowSave
    If .FileName <> "" Then
      txtDest.Text = .FileName
    End If
  End With

End Sub

Private Sub cmdBrowseSrc_Click()

  With CommonDialog1
    .DialogTitle = "Select a huge source file"
    .Flags = cdlOFNHideReadOnly Or cdlOFNFileMustExist
    .FileName = txtSource.Text
    .ShowOpen
    If .FileName <> "" Then
      txtSource.Text = .FileName
    End If
  End With
  
End Sub

Private Sub cmdClose_Click()
  Unload Me
End Sub

Private Sub cmdStart_Click()

  Dim fMove As Boolean
  Dim lRet As Long, fCancel As Long
  Dim oProgDlg As ProgressDialog
  Dim ow As IOleWindow
  Dim hwndProgDlg As Long
  Dim sCompactPath As String
  
  
  fMove = (optMove.Value = True)

  Set oProgDlg = New ProgressDialog

  With oProgDlg
    .SetTitle IIf(fMove, "Moving file...", "Copying file...")
    .SetAnimation m_hLibShell32, IIf(fMove, RES_AVI_FILEMOVE, RES_AVI_FILECOPY)
    .SetLine 1, txtSource.Text, 1&, ByVal 0&
    .SetLine 2, txtDest.Text, 1&, ByVal 0&
    .SetCancelMsg "Please wait...", ByVal 0&
    .StartProgressDialog Me.hwnd, Nothing, PROGDLG_MODAL Or PROGDLG_AUTOTIME Or PROGDLG_NOMINIMIZE, ByVal 0&
  End With
  
  On Error Resume Next
  Set ow = oProgDlg
  On Error GoTo 0
  
  ' Workaround for PROGDLG_NOMINIMIZE bug
  If Not (ow Is Nothing) Then
    ow.GetWindow hwndProgDlg
    RemoveMinButton hwndProgDlg
    Set ow = Nothing
  End If
  
  oProgDlg.Timer PDTIMER_RESET, ByVal 0&
  
  If fMove Then
    lRet = MoveFileWithProgress(txtSource.Text, txtDest.Text, _
      AddressOf CopyProgressRoutine, ByVal ObjPtr(oProgDlg), MOVEFILE_COPY_ALLOWED)
  Else
    lRet = CopyFileEx(txtSource.Text, txtDest.Text, AddressOf CopyProgressRoutine, _
      ByVal ObjPtr(oProgDlg), fCancel, COPY_FILE_FAIL_IF_EXISTS)
  End If
  
  oProgDlg.StopProgressDialog
  Set oProgDlg = Nothing
  
  If lRet Then
    MsgBox txtSource.Text & IIf(fMove, " moved", " copied") & " successfully."
  Else
  ' If file operation is canceled, Err.LastDllError will return
    ' 1235 (&H4D3) "The request was aborted."
    MsgBox IIf(fMove, "MoveFileWithProgress", "CopyFileEx") & _
      " failed with error " & Err.LastDllError
  End If
  
End Sub

Private Sub Form_Load()

  ' Load Shell32 to access the AVI animations resources
  m_hLibShell32 = LoadLibrary("shell32.dll")
  
End Sub

Private Sub Form_Unload(Cancel As Integer)

  Call FreeLibrary(m_hLibShell32)
  
End Sub

'
' Sub RemoveMinButton
'
' Description:  Removes the minimize titlebar button from the window
'               specified by the hwnd parameter.
'
Private Sub RemoveMinButton(ByVal hwnd As Long)

  Dim lStyle As Long
  
  
  lStyle = GetWindowLong(hwnd, GWL_STYLE)
  If (lStyle And WS_MINIMIZEBOX) Then
    ' Remove minimize style flag
    lStyle = lStyle And (Not WS_MINIMIZEBOX)
    Call SetWindowLong(hwnd, GWL_STYLE, lStyle)
  End If
  
End Sub

